<%--Definition der JSP-Seite: 
    -Importieren bentigter Dateien
    -Fehlerseite festlegen.
    -ContentType der Ausgabe festlegen (wenn wir das nicht tun, kommen Umlaute falsch an).
     Hinweis: die Festlegung des Contentypes hier hat nichts mit dem Meta-Tag im HTML-Header
     zu tun. Dieses dient dazu, dass der Browser die Seite im richtigen Encoding darstellt.
     Der ContentType hier sorgt dafr, dass der Webserver berhaupt etwas "richtiges" erzeugt.
    -ErrorPage definieren (Seite wird bei Exceptions aufgerufen).
    -session=true legt fest, dass wir einen SessionContext haben, in dem wir Variablen speichern knnen.
--%>
<%@page
	import="de.fhw.swtvertiefung.knauf.jsp1.Seitenlaengen, java.util.Iterator"
	contentType="text/html; charset=windows-1252" errorPage="/errorpage.jsp"
	session="true"%>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head>
<title>Test fr JSP</title>
<meta http-equiv="content-type"
	content="text/html; charset=Windows-1252" />
</head>
<body>
<h1>Test fr JSP</h1>
<%--Die Request-Parameter werden in eine Klasse "seitenlnge" gesetzt, aus der
    sie anschlieend geholt werden knnen. Diese Bean ist nur whrend dieser Seite
    gltig. Beim nchsten Aufruf wird sie neu erzeugt. --%>
<jsp:useBean id="seitenlaenge"
	class="de.fhw.swtvertiefung.knauf.jsp1.Seitenlaengen" scope="page">
	<%--Setzen der drei Properties der Bean mit der ID "seitenlaenge" ("id"-Attribut der Bean = "name"-Attribut des setProperty-Tags. 
      Der Wert ist nicht hartcodiert (wrde mittels "value=..." geschehen, 
      sondern wird aus dem Requestparameter geholt, der bei "param" angegeben ist. --%>
	<jsp:setProperty property="a" name="seitenlaenge" param="a"></jsp:setProperty>
	<jsp:setProperty property="b" name="seitenlaenge" param="b"></jsp:setProperty>
	<jsp:setProperty property="c" name="seitenlaenge" param="c"></jsp:setProperty>
</jsp:useBean>

<%--Alle bisherigen Berechnungen (sofern sie gltig sind) werden auerdem
    in einer zweiten Bean gespeichert, die in der Session abgelegt ist. --%>
<jsp:useBean id="historie"
	class="de.fhw.swtvertiefung.knauf.jsp1.Historie" scope="session">
</jsp:useBean>
<%
//Ist es der erste Aufruf oder wurde auf "Berechnen" geklickt.
if (request.getParameter("submit") == null)
{
  //Erster Aufruf: Nur Formular ausgeben.
}
else
{
  // Zweiter bis n-ter Aufruf: Berechnen.
  double dblA = seitenlaenge.getA();
  double dblB = seitenlaenge.getB();
  double dblC = seitenlaenge.getC();
  //Parametercheck:
  if (dblA <= 0.0 || dblB <= 0.0 || dblC <= 0.0)
    throw new Exception ("Eingabe ist negativ !");


  //Auerdem zufgen zur Historie:
  historie.addSeitenlaenge (seitenlaenge);
  
  double dblVolume = dblA * dblB * dblC;
  double dblSurface = 2 * (dblA + dblB) + 2 * (dblB + dblC) + 2 * (dblA + dblC);
  %>

Volumen = <%=dblVolume%>, Oberflche = <%=dblSurface%>
<br />
<br />
<br />
<%
}
%>
<%--Das Formular fr die Eingabe der drei Zahlen wird als JSP-Include eingebunden (auch wenn dies hier nicht ntig wre). --%>
<jsp:include page="input.jsp" flush="" />
<%--Jetzt erfolgt die Ausgabe der bisherigen Berechnungen, die in der Session gespeichert
    wurden. --%>
<h2>Ihre letzten Berechnungen waren:</h2>
<br />
<% Iterator iterator = historie.iterator();
   while (iterator.hasNext() == true)
   {
     Seitenlaengen seitenlaengeAktuell = (Seitenlaengen) iterator.next(); 
     %>
a=<%=seitenlaengeAktuell.getA()%>, b=<%=seitenlaengeAktuell.getB()%>, c=<%=seitenlaengeAktuell.getC()%>
<br />
<%
   }
%>
</body>
</html>
